import machine, time, math
from machine import Pin, PWM
interwaly = [
    [16,15],[9,8],[6,5],[5,4],[4,3],[45,32],[3,2],[8,5],[5,3],[9,5],[15,8],[2,1]
    ]

adc_f = machine.ADC(machine.Pin(34)) #do zmiany czestotliwosci
adc_f.atten(machine.ADC.ATTN_11DB) #od 0 do 4095
adc_wybor = machine.ADC(machine.Pin(13)) #do wyboru interwalu 
adc_wybor.atten(machine.ADC.ATTN_11DB) 
on_limit = False
count_harmonic = 0
count_melodic = 0
pin1 = machine.Pin(5, machine.Pin.IN, machine.Pin.PULL_UP)


def linear_to_inverse_logarithmic(linear_value,f_limit): #powolne zmniejszanie czestotliwosci przy malych wartosciach
    # Define your scaling parameters here
    min_linear = 0
    max_linear = 4095
    min_inverse_log = 1
    max_inverse_log = f_limit  # Adjust this according to your requirements

    # Scale the linear reading to an inverse logarithmic value
    return min_inverse_log + (max_inverse_log - min_inverse_log) * (math.exp(linear_value / max_linear * 4) - 1) / (math.exp(4) - 1)


while True:
    pot_value_wybor = int(adc_wybor.read()/372.27)  # odczyt plus przeskalowanie od 0 do 11 (12 liczb)
    print("Potentiometer choice:", pot_value_wybor)
    
    ratio_lower = interwaly[pot_value_wybor][1]
    ratio_upper = interwaly[pot_value_wybor][0]
    f_limit = 700/ratio_upper 
    while pin1.value()==0: #wcisniety przycisk powoduje brak dzwieku
        beeper1 = PWM(Pin(4), freq=ratio_lower*pot_value, duty=0)
        beeper2 = PWM(Pin(2), freq = ratio_upper*pot_value , duty = 0)
        time.sleep(0.1)
    on_limit = False #f_limit
    pot_value = int(linear_to_inverse_logarithmic(adc_f.read(),f_limit))  #odczyt z potencjometru
    #print("Potentiometer Value freq:", pot_value)
    if count_harmonic>2 and count_melodic>2: #reset po odegraniu melodycznie i harmonicznie
        count_harmonic = 0
        count_melodic = 0
    
    if (pot_value > f_limit-10): #po paru cyklach ma zmienic na tryb melodyczny
        on_limit = True
        count_harmonic += 1
    else:
        count_harmonic = 0 #reset wartosci jesli zmieniono czestotliwosc w trakcie naliczania
        count_melodic = 0
    beeper1 = PWM(Pin(4), freq=ratio_lower*pot_value, duty=512)
    if on_limit == True and count_harmonic >3 and count_melodic<3: #odegrano harmonicznie ale nie melodycznie 
        time.sleep(1)
        beeper1.duty(0)
        count_melodic += 1
    beeper2 = PWM(Pin(2), freq = ratio_upper*pot_value , duty = 512)
    time.sleep(1)
    beeper1.deinit()
    beeper2.deinit()